=== debian/changelog ===
fltk1.3 (1.3.5-3) unstable; urgency=medium

  * Standards-Version: 4.5.1 (routine-update)
  * Add salsa-ci file (routine-update)
  * No tab in license text (routine-update)
  * watch file standard 4 (routine-update)

 -- Aaron M. Ucko <ucko@debian.org>  Sat, 06 Feb 2021 22:54:55 -0500

fltk1.3 (1.3.5-2) unstable; urgency=medium

  * Trim trailing whitespace.
  * debian/copyright: use spaces rather than tabs to start continuation lines.
  * Use secure URI in Homepage field and debian/watch.
  * Set debhelper-compat version in Build-Depends.
  * Use AC_PATH_TOOL for upstream's manual PKGCONFIG setting.
    (PKG_PROG_PKG_CONFIG sets PKG_CONFIG instead.)
  * debian/libfltk1.3-dev.NEWS: Retire (gratuitous carryover from fltk1.1).
  * debian/fluid.NEWS: Keep, but reformat without leading asterisks.
  * Override notable Lintian false positives (fake CMakeCache.txt to satisfy
    FindFLTK.cmake, linkage of libc-independent libfltk_cairo.so.1.3).

 -- Aaron M. Ucko <ucko@debian.org>  Sun, 01 Nov 2020 21:50:55 -0500

fltk1.3 (1.3.5-1) unstable; urgency=medium

  * New upstream release.
  * debian/compat: Advance to Debhelper 13.
  * debian/control:
    - Build-Depends: Advance minimum debhelper version to 13~ accordingly;
      swap transitional libgl1-mesa-dev package with formerly virtual
      libgl-dev package.
    - libfltk1.3-dev Recommends: Bypass libgl1-mesa-dev altogether.
    - Standards-Version: 4.5.0 (already compliant).
  * debian/copyright: Update years.
  * debian/fltk1.3-doc.lintian-overrides: Drop (thanks to #736360).
  * debian/libfltk1.3-compat-headers.install: Add new FL/platform.h.
  * debian/libfltk-gl1.3.symbols: Add the one new symbol.
  * debian/rules: Retire configure.saved business, no longer needed AFAICT.

 -- Aaron M. Ucko <ucko@debian.org>  Tue, 23 Jun 2020 19:52:06 -0400

fltk1.3 (1.3.4-10) unstable; urgency=medium

  [ Gianfranco Costamagna ]
  * Explicitly install CHANGES file, to avoid confusion
    and build failures when debhelper doesn't install changelogs
    by default (e.g. Ubuntu).  (MR: !1.)

  [ Aaron M. Ucko ]
  * debian/compat: Advance to Debhelper 12, notably yielding DWZ-compressed
    symbols and fully uncompressed examples.
  * debian/control:
     - Advance minimum debhelper version to 12~ accordingly.
     - Standards-Version: 4.4.1 (already compliant).
  * debian/fltk1.3-doc.docs: Take over coverage of fltk.pdf (available
    nowadays with the correct name and freshly generated contents).
  * debian/fltk1.3-doc.install: Take over coverage of HTML docs.
  * debian/rules:
    - Stop running "make install" in documentation/ to avoid populating
      debian/tmp/usr/share/man with uncompressed man and cat(!)  pages
      (about which dh_missing otherwise now complains); also stop
      explicitly (re)installing fltk.pdf.
    - Explicitly ignore usr/include/Fl (deliberately dropped, even in
      libfltk1.3-compat-headers) to address one last dh_missing complaint.
    - Stop explicitly running dh_makeshlibs -V, redundant as of DH 12.
  * documentation/make_pdf: Loosen caption de-hyperlinking to
    accommodate (but not require) interposed mboxes, as produced by Doxygen
    1.8.16 (currently in experimental).
  * documentation/src/fltk-book.tex.in: Explicitly \usepackage{ifthen} for
    the sake of several constructs in doxygen.sty, which has just a
    commented-out \RequirePackage call for it as of 1.8.16.  (Together with
    the above, closes: #943426.)
  * test/Makefile: Link FLTK libraries dynamically, notably for games.
    (Done years ago for 1.1, but accidentally missed for 1.3.)

 -- Aaron M. Ucko <ucko@debian.org>  Sat, 26 Oct 2019 22:16:56 -0400
